# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetPackerImageIterationBuildResult',
    'GetPackerImageIterationBuildImageResult',
]

@pulumi.output_type
class GetPackerImageIterationBuildResult(dict):
    def __init__(__self__, *,
                 cloud_provider: str,
                 component_type: str,
                 created_at: str,
                 id: str,
                 images: Sequence['outputs.GetPackerImageIterationBuildImageResult'],
                 labels: Mapping[str, str],
                 packer_run_uuid: str,
                 status: str,
                 updated_at: str):
        """
        :param str cloud_provider: Name of the cloud provider this image is stored-in, if any.
        :param str component_type: Name of the builder that built this. Ex: 'amazon-ebs.example'.
        :param str created_at: Creation time of this build.
        :param str id: HCP ID of this build.
        :param Mapping[str, str] labels: Labels for this build.
        :param str packer_run_uuid: Packer generated UUID of this build.
        :param str status: Status of this build. DONE means that all images tied to this build were successfully built.
        :param str updated_at: Time this build was last updated.
        """
        pulumi.set(__self__, "cloud_provider", cloud_provider)
        pulumi.set(__self__, "component_type", component_type)
        pulumi.set(__self__, "created_at", created_at)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "images", images)
        pulumi.set(__self__, "labels", labels)
        pulumi.set(__self__, "packer_run_uuid", packer_run_uuid)
        pulumi.set(__self__, "status", status)
        pulumi.set(__self__, "updated_at", updated_at)

    @property
    @pulumi.getter(name="cloudProvider")
    def cloud_provider(self) -> str:
        """
        Name of the cloud provider this image is stored-in, if any.
        """
        return pulumi.get(self, "cloud_provider")

    @property
    @pulumi.getter(name="componentType")
    def component_type(self) -> str:
        """
        Name of the builder that built this. Ex: 'amazon-ebs.example'.
        """
        return pulumi.get(self, "component_type")

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> str:
        """
        Creation time of this build.
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        HCP ID of this build.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def images(self) -> Sequence['outputs.GetPackerImageIterationBuildImageResult']:
        return pulumi.get(self, "images")

    @property
    @pulumi.getter
    def labels(self) -> Mapping[str, str]:
        """
        Labels for this build.
        """
        return pulumi.get(self, "labels")

    @property
    @pulumi.getter(name="packerRunUuid")
    def packer_run_uuid(self) -> str:
        """
        Packer generated UUID of this build.
        """
        return pulumi.get(self, "packer_run_uuid")

    @property
    @pulumi.getter
    def status(self) -> str:
        """
        Status of this build. DONE means that all images tied to this build were successfully built.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="updatedAt")
    def updated_at(self) -> str:
        """
        Time this build was last updated.
        """
        return pulumi.get(self, "updated_at")


@pulumi.output_type
class GetPackerImageIterationBuildImageResult(dict):
    def __init__(__self__, *,
                 created_at: str,
                 id: str,
                 image_id: str,
                 region: str):
        """
        :param str created_at: Creation time of this iteration
        :param str id: The ID of this resource.
        """
        pulumi.set(__self__, "created_at", created_at)
        pulumi.set(__self__, "id", id)
        pulumi.set(__self__, "image_id", image_id)
        pulumi.set(__self__, "region", region)

    @property
    @pulumi.getter(name="createdAt")
    def created_at(self) -> str:
        """
        Creation time of this iteration
        """
        return pulumi.get(self, "created_at")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The ID of this resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="imageId")
    def image_id(self) -> str:
        return pulumi.get(self, "image_id")

    @property
    @pulumi.getter
    def region(self) -> str:
        return pulumi.get(self, "region")


